"""
event_name : copy-angular-component
description : Add Angular libraries to project
config format:

**Place Your Sample configuration here here**

"""
import os
from jennie.rule_engine.events._helper import download_text_file, list_all_files_from_folder, upload_text_file
from jennie.rule_engine.events.constants import *

class event_copy_angular_component():
    def __init__(self, user_key, app_name, type):
        self.user_key = user_key
        self.app_name = app_name
        self.type = type
        self.sample_conf = {
            KEY_COMPONENTS: [{
                KEY_COMPONENT_NAME: "",
                KEY_COMPONENT_FILES: [],
            }],
            KEY_EVENT_TYPE: EVENT_COPY_ANGULAR_COMPONENT
        } # replace with sample configuration.


    def execute(self, event_info):
        """
        :param event: event information
        :return: True / False
        """
        for component in event_info[KEY_COMPONENTS]:
            os.system("ng g c {}".format(component[KEY_COMPONENT_NAME]))
            for file in component[KEY_COMPONENT_FILES]:
                file_content = download_text_file(file)
                filename = file.split("/")[-1]
                open("src/app/{}/{}".format(component[KEY_COMPONENT_NAME], filename), "w").write(file_content)
        return True

    def build_event(self):
        """
        :return: event_info
        """
        event_info = {
            KEY_EVENT_TYPE: EVENT_COPY_ANGULAR_COMPONENT
        }
        event_info[KEY_COMPONENTS] = []
        component_names_txt = input(INPUT_MESSAGE_LIBS)
        component_names = component_names_txt.replace(" ,", ",").replace(", ", ",").split(",")
        for component in component_names:
            component_path = os.path.join(os.getcwd(), "src/app/{}".format(component))
            if not os.path.exists(component_path):
                print ("Component does not exits :", component)
                return False
            files_list = list_all_files_from_folder(component_path)
            curent_component = {
                KEY_COMPONENT_NAME: component
            }
            curent_component[KEY_COMPONENT_FILES] = []
            for file in files_list:
                if file.split(".")[-1] in ["html", "css", "ts"]:
                    filepath = os.path.join(component_path, file)
                    file_link = upload_text_file(filepath, self.app_name, self.type, self.user_key)
                    curent_component[KEY_COMPONENT_FILES].append(file_link)
            event_info[KEY_COMPONENTS].append(curent_component)
        return event_info

    def validate(self, event_info):
        """
        Validate Configuration.
        :param event: event info
        :return: event_info / False
        """
        if KEY_COMPONENTS not in event_info:
            print(ERR_COMPONENT_NAMES_NOT_PRESENT)
            return False

        if str(type(event_info[KEY_COMPONENTS])) != "<class 'list'>":
            print(ERR_COMPONENT_NAMES_SHOULD_BE_LIST)
            return False
        return event_info
